//Minimum Yaylan Aa Problemi: Prim Algoritmas
//@author Ibrahim Kucukkoc ikucukkoc@baun.edu.tr

import java.awt.EventQueue;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

public class MinSpTree {

	static Scanner klavye = new Scanner(System.in);

	static ArrayList<ArrayList<Integer>> ag = new ArrayList<ArrayList<Integer>>();
	static ArrayList<Integer> agac = new ArrayList<Integer>(); // MST yi tutacak olan ArrayList
	static boolean[] atandiMi = new boolean[ag.size()];
	static int toplamYol;
	
	static ArrayList<ArrayList<Integer>> baglantilar = new ArrayList<ArrayList<Integer>>();
	static String inputFileName;
	static String outputFileName;
	static boolean DosyayaYazdirilsinmi;
	

	public static void main(String[] args) throws IOException {
		
		/**
		 * Launch the application.
		 */
		App window = new App();
		window.frame.setVisible(true);
		
	}
	
	
	public static void calistir() throws IOException {
		
		//girdi ve kt dosya isimlerini oku
		inputFileName = App.tfInputFile.getText()+".txt";
		outputFileName = App.tfOutputFileName.getText()+".txt";
		
		//agiOlustur1(); //A klavyeden girilen deerlerle olutur
		//agiOlustur2(); //A nceden girilmi deerlerle olutur
		agiOlustur3(); //A dosyadan oku
		MSTHesapla();
		System.out.println(baglantilar);
		
		
		if (DosyayaYazdirilsinmi) {
			DosyayaYazdir();
		}
	}




	private static void EkranaRaporYazdir() {
		
		
	}


	private static void agiOlustur3() throws IOException {
		// dosyadan oku
		System.out.println("agiOlustur3() metodu arld");
				
		int r = 0 ; //dm says, balang deeri

		File dosya = new File(inputFileName);  
	    Scanner klavye = new Scanner(dosya);
	    ArrayList<Integer> integers = new ArrayList<>();
	    while (klavye.hasNext()) {
	        if (klavye.hasNextInt()) {
	            integers.add(klavye.nextInt());
	        } else {
	            klavye.next();
	        }
	    }
	    System.out.println(integers);
	    	    
	    r=(int) Math.sqrt(integers.size());
	    
		for (int i=0; i<r; i++) {
			ag.add(new ArrayList<Integer>());
			for (int j =0; j<r; j++) {
				ag.get(i).add(integers.get(r*(i)+j));
			}
		}
		System.out.println(ag);
			
		
		
		
	}

	private static void MSTHesapla() {
		int enYakinDugum;
		atandiMi = new boolean[ag.size()];
		Arrays.fill(atandiMi, false);
		System.out.println("atandiMi.length:" + atandiMi.length);
		
		ArrayYazdir(atandiMi, "AtandiMi");
		// balang Dmn Belirle ve MST'ye ekle
		agac.add(0);
		atandiMi[0] = true;
		toplamYol = 0;		

		while (agac.size()<ag.size()) {
			enYakinDugum = enYakinDugumBul();
			agac.add(enYakinDugum);
			atandiMi[enYakinDugum] = true;
			System.out.println("agac: " + agac);
			System.out.println("toplamYol: " + toplamYol);
			System.out.println("baglantilar: " + baglantilar);
			System.out.println(); System.out.println();
		}
	}

	private static int enYakinDugumBul() {
		//int enYakinMesafe = ;
		int minIndex = Integer.MAX_VALUE;
		int minMesafe = Integer.MAX_VALUE;
		int minParent = Integer.MAX_VALUE;
		baglantilar.add(new ArrayList<Integer>());
		
		for (int kok = 0; kok < agac.size(); kok++) {
			System.out.println();
			System.out.println("kok: " + kok);
			for (int i = 0; i < ag.size(); i++) {
				System.out.println("i: " + i);
				System.out.println("ag.get(kok).get(i): " + ag.get(kok).get(i));
				System.out.println("minMesafe: " + minMesafe);
				System.out.println("atandiMi[i]: " + atandiMi[i]);

				if (ag.get(agac.get(kok)).get(i)!=0 && (ag.get(agac.get(kok)).get(i) < minMesafe) && atandiMi[i] == false) {
					minIndex = i;
					minParent = (agac.get(kok));
					minMesafe = ag.get(agac.get(kok)).get(i);
				}
				
				System.out.println("minIndex: " + minIndex);
				System.out.println("minParent: " + minParent);
				System.out.println("minMesafe: " + minMesafe);
			}
		}
		baglantilar.get(baglantilar.size()-1).add(minParent);
		baglantilar.get(baglantilar.size()-1).add(minIndex);
		toplamYol = toplamYol + minMesafe;
		
		return minIndex; //return new int[] {minIndex, minParent};
	}

	
	private static void agiOlustur2() {
		ag.add(new ArrayList<Integer>());
		ag.get(ag.size() - 1).addAll(Arrays.asList(0, 2, 0, 6, 0));
		ag.add(new ArrayList<Integer>());
		ag.get(ag.size() - 1).addAll(Arrays.asList(2, 0, 3, 8, 5));
		ag.add(new ArrayList<Integer>());
		ag.get(ag.size() - 1).addAll(Arrays.asList(0, 3, 0, 0, 7));
		ag.add(new ArrayList<Integer>());
		ag.get(ag.size() - 1).addAll(Arrays.asList(6, 8, 0, 0, 9));
		ag.add(new ArrayList<Integer>());
		ag.get(ag.size() - 1).addAll(Arrays.asList(0, 5, 7, 9, 0));
		System.out.println("ag: " + ag);

	}
	

	private static void agiOlustur1() {
		System.out.println("Dm Saysn Giriniz: ");
		int r = klavye.nextInt();
		int c = r;
		//System.out.println("Stun Saysn (c) Giriniz: ");
		//int c = klavye.nextInt();

		for (int i = 0; i < r; i++) {
			ag.add(new ArrayList<Integer>());
			for (int j = 0; j < c; j++) {
				System.out.println("An " + i + "-" + j + " indeksi iin hcre deerini giriniz");
				ag.get(i).add(klavye.nextInt());
			}

			System.out.println("ag: " + ag);
		}
	}
	
	private static void DosyayaYazdir() throws IOException {
		//String str = "Bunu dosyaya yazdir";
		File dosya2 = new File(outputFileName);
		
		if (!dosya2.exists()) {
			dosya2.createNewFile();
		}
		
		/* eer bo dosyaya yazlmak isteniorsa, dosya mevcut ise sil ve yeniden olutur. 
		if (dosya2.exists() && dosya2.isFile()) {
			dosya2.delete();
		}
		*/
		
		FileWriter fw = new FileWriter(dosya2, false);//appends if true // false ise mevcut ierik silinip batan yazlr
		BufferedWriter bw = new BufferedWriter(fw);
		bw.write("-- Prim Algoritmas Baaryla Sonland");
		bw.newLine();
		bw.write("Birbirine Balanan Dm Says: " + String.valueOf(MinSpTree.ag.size())+"\n");
		bw.newLine();
		for (int i=0; i<baglantilar.size(); i++) {
			bw.write("[");
			bw.write(String.valueOf(baglantilar.get(i).get(0)));
			bw.write(",");			
			bw.write(String.valueOf(baglantilar.get(i).get(1)));
			bw.write("]");
		}
		bw.newLine();
		bw.write("Toplam Yol: " + toplamYol);
		bw.close();
		
	}
	

	private static void ArrayYazdir(boolean[] dizi, String diziAdi) {
		System.out.println(diziAdi);
		
		for (int i=0; i <dizi.length; i++) {
			System.out.print(dizi[i] + " ");
		}
		System.out.println();
		
	}

}
